
#include <cstdio>
#include <ctime>
#include <cmath>
#include "exa-base.h"
#include "exa-image.h"
#include "exa-font.h"
#include "exa-particles.h"
#include <list>
#include <GL/gl.h>

#define posun 15
#define pauza_strely 1.0
#define rychlost_strely 45

float timex;

int pocet_hracov=2,sirka_ploxy=18,vyska_ploxy=14,
	pocet_prekazok=0,cas=60,prvy_hrac=1;
class hrac;
class strela;
class kokocina;
exaGLFont napis;
GLuint textura,textura2;
GLuint textura3,textura4;
GLuint hruscak1,hruscak2;
GLuint hruscak3,hruscak4;
GLuint druhy1, druhy2, druhy3, druhy4;
GLuint pozadie1,obr_vybux,obr_brokovka, obr_neviditelnost,
	   obr_bomba, obr_nesmrtelnost, obr_blato;
int total_end=0;
bool done=false;
std::list<strela> v;

exaParticleSystem ps;

void load_texture()
{
		int x,y,b;
		char*d;

		if(exaImageReadPNG("hurnak1.png",&x,&y,&b,&d)){
				textura=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");

		if(exaImageReadPNG("hurnak2.png",&x,&y,&b,&d)){
				textura2=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");

		if(exaImageReadPNG("hurnak3.png",&x,&y,&b,&d)){
				textura3=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");

		if(exaImageReadPNG("hurnak4.png",&x,&y,&b,&d)){
				textura4=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");

		if(exaImageReadPNG("hruscak1.png",&x,&y,&b,&d)){
				hruscak1=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");

		if(exaImageReadPNG("hruscak2.png",&x,&y,&b,&d)){
				hruscak2=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");

		if(exaImageReadPNG("hruscak3.png",&x,&y,&b,&d)){
				hruscak3=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");

		if(exaImageReadPNG("hruscak4.png",&x,&y,&b,&d)){
				hruscak4=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");

		if(exaImageReadPNG("pozadie.png",&x,&y,&b,&d)){
				pozadie1=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");

		if(exaImageReadPNG("zbran1.png",&x,&y,&b,&d)){
				obr_brokovka=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");

		if(exaImageReadPNG("oblacik.png",&x,&y,&b,&d)){
				obr_neviditelnost=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");

		if(exaImageReadPNG("nesmrt.png",&x,&y,&b,&d)){
				obr_nesmrtelnost=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");

		if(exaImageReadPNG("bloodsplat.png",&x,&y,&b,&d)){
				obr_bomba=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");

		if(exaImageReadPNG("mud.png",&x,&y,&b,&d)){
				obr_blato=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");

		if(exaImageReadPNG("particle.png",&x,&y,&b,&d)){
				obr_vybux=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");

		if(exaImageReadPNG("druhy1.png",&x,&y,&b,&d)){
				druhy1=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");

		if(exaImageReadPNG("druhy2.png",&x,&y,&b,&d)){
				druhy2=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");

		if(exaImageReadPNG("druhy3.png",&x,&y,&b,&d)){
				druhy3=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");

		if(exaImageReadPNG("druhy4.png",&x,&y,&b,&d)){
				druhy4=exaImageMakeGLTex(x,y,b,d);
				exaImageFree(d);
		} else printf("cosi sa posralo s texturou more\n");
}

void release_texture()
{
		exaImageDelGLTex(textura); //uvolnime data z opengl
		exaImageDelGLTex(textura2); //uvolnime data z opengl
		exaImageDelGLTex(textura3); //uvolnime data z opengl
		exaImageDelGLTex(textura4); //uvolnime data z opengl
		exaImageDelGLTex(hruscak1); //uvolnime data z opengl
		exaImageDelGLTex(hruscak2); //uvolnime data z opengl
		exaImageDelGLTex(hruscak3); //uvolnime data z opengl
		exaImageDelGLTex(hruscak4); //uvolnime data z opengl
		exaImageDelGLTex(pozadie1); //uvolnime data z opengl
		exaImageDelGLTex(obr_vybux); //uvolnime data z opengl
		exaImageDelGLTex(obr_neviditelnost); //uvolnime data z opengl
		exaImageDelGLTex(obr_bomba); //uvolnime data z opengl
		exaImageDelGLTex(obr_nesmrtelnost); //uvolnime data z opengl
		exaImageDelGLTex(obr_blato); //uvolnime data z opengl
		exaImageDelGLTex(druhy1); //uvolnime data z opengl
		exaImageDelGLTex(druhy2); //uvolnime data z opengl
		exaImageDelGLTex(druhy3); //uvolnime data z opengl
		exaImageDelGLTex(druhy4); //uvolnime data z opengl
}

class strela
{
		public:
				int smer,povodca,trojita;
				float x,y,z;
				char farba;
				strela() {x=y=z=0;}
				strela(float a, float b, float c, int s, int p, int t, char f)
				{x=a; y=b; z=c; smer=s; povodca=p; trojita=t; farba=f;}
};

class hrac
{
		public:
				float x,y,z;
				int smer, cas_nah_pohybu, 
					pom_cnp, trojita_strela,neviditelny,nesmrtelny,zabil, mrtvy;
				float pauza;
				bool zivy;
				long cas_smrti;
				hrac() 
				{
						x=y=z=0; zivy=true, pauza=0; smer=1;
						cas_smrti=0;cas_nah_pohybu=200;
						trojita_strela=0;neviditelny=0;nesmrtelny=0; zabil=mrtvy=0;
				}
				void vynuluj_sa(float a, float b, float c, int s)
				{	
					x=a; y=b; z=c; smer=s; zivy=true; pauza=0; cas_smrti=0; 
					cas_nah_pohybu=200; pom_cnp=0; trojita_strela=0;
					neviditelny=0; nesmrtelny=0;				}
				inline hrac(float a, float b, float c, int s)
				{	
						vynuluj_sa(a, b, c, s);
						zabil=mrtvy=0;
				}
};

hrac pole_hracov[8];

class ob_cas
{
		long zac;
		long akt;
		public:
		ob_cas() {zac=time(NULL);}
		int daj_cas() {akt=time(NULL); return (int) akt-zac;}
		void vynuluj() {zac=time(NULL);}
};

class kokocina
{
		public:
				bool zobrazit;
				float x,y,z;
				kokocina() {zobrazit=false; x=0; y=0; z=0;}
				kokocina(float a, float b, float c)	{zobrazit=false; x=a; y=b; z=c;}
				void zmen_polohu(float a, float b, float c) {x=a; y=b; z=c;}
				virtual void zobraz()=0;
				int over_prelinanie_kokociny();
};

class brokovka : public kokocina
{
		public:
				brokovka() {}
				brokovka(float a, float b, float c) : kokocina(a,b,c) {}
				void zobraz()
				{
					glEnable(GL_BLEND);
					//glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
						glPushMatrix();
						glTranslatef(x,y,0);
						glColor3f(1,1,1);
						glBindTexture(GL_TEXTURE_2D,obr_brokovka);

						glBegin(GL_QUADS);
						glTexCoord2f(0,0);
						glVertex2f(-0.7,-0.7);
						glTexCoord2f(1,0);
						glVertex2f(0.7,-0.7);
						glTexCoord2f(1,1);
						glVertex2f(0.7,0.7);
						glTexCoord2f(0,1);
						glVertex2f(-0.7,0.7);
						glEnd();
						glPopMatrix();
					glDisable(GL_BLEND);
				}
};

class neviditelnost : public kokocina
{
		public:
				neviditelnost() {}
				neviditelnost(float a, float b, float c) : kokocina(a,b,c) {}
				void zobraz()
				{
					glEnable(GL_BLEND);
						glPushMatrix();
						glTranslatef(x,y,0);
						glColor3f(1,1,1);
						glBindTexture(GL_TEXTURE_2D,obr_neviditelnost);

						glBegin(GL_QUADS);
						glTexCoord2f(0,0);
						glVertex2f(-0.7,-0.7);
						glTexCoord2f(1,0);
						glVertex2f(0.7,-0.7);
						glTexCoord2f(1,1);
						glVertex2f(0.7,0.7);
						glTexCoord2f(0,1);
						glVertex2f(-0.7,0.7);
						glEnd();
						glPopMatrix();
					glDisable(GL_BLEND);
				}
};

class nesmrtelnost : public kokocina
{
		public:
				nesmrtelnost() {}
				nesmrtelnost(float a, float b, float c) : kokocina(a,b,c) {}
				void zobraz()
				{
					glEnable(GL_BLEND);
						glPushMatrix();
						glTranslatef(x,y,0);
						glColor3f(1,1,1);
						glBindTexture(GL_TEXTURE_2D,obr_nesmrtelnost);

						glBegin(GL_QUADS);
						glTexCoord2f(0,0);
						glVertex2f(-0.7,-0.7);
						glTexCoord2f(1,0);
						glVertex2f(0.7,-0.7);
						glTexCoord2f(1,1);
						glVertex2f(0.7,0.7);
						glTexCoord2f(0,1);
						glVertex2f(-0.7,0.7);
						glEnd();
						glPopMatrix();
					glDisable(GL_BLEND);
				}
};

class bomba : public kokocina
{
		public:
				bomba() {}
				bomba(float a, float b, float c) : kokocina(a,b,c) {}
				void zobraz()
				{
						glPushMatrix();
						glTranslatef(x,y,0);
						glColor3f(1,1,1);
						glBindTexture(GL_TEXTURE_2D,obr_bomba);

						glBegin(GL_QUADS);
						glTexCoord2f(0,0);
						glVertex2f(-0.7,-0.7);
						glTexCoord2f(1,0);
						glVertex2f(0.7,-0.7);
						glTexCoord2f(1,1);
						glVertex2f(0.7,0.7);
						glTexCoord2f(0,1);
						glVertex2f(-0.7,0.7);
						glEnd();
						glPopMatrix();
				}
};

class prekazky
{
		public:
				float x,y,polomer;
				prekazky(float a, float b, float r) {x=a; y=b; polomer=r;}
				void zobraz()
				{
						glPushMatrix();
						glTranslatef(x,y,0);
						glColor3f(1,1,1);
						glBindTexture(GL_TEXTURE_2D,obr_blato);

						glBegin(GL_QUADS);
						glTexCoord2f(0,0);
						glVertex2f(-polomer,-polomer);
						glTexCoord2f(1,0);
						glVertex2f(polomer,-polomer);
						glTexCoord2f(1,1);
						glVertex2f(polomer,polomer);
						glTexCoord2f(0,1);
						glVertex2f(-polomer,polomer);
						glEnd();
						glPopMatrix();
				}
};

prekazky *prek[10];

bool over_prelinanie_prekazok(float a, float b)
{
		int i;

		for(i=0; i<pocet_prekazok; ++i)
		{
				if(prek[i]->x - prek[i]->polomer<=a
								&& prek[i]->x + prek[i]->polomer>=a
								&& prek[i]->y - prek[i]->polomer<=b
								&& prek[i]->y + prek[i]->polomer>=b)
						return false;
		}
		return true;
}

int over_bod_kokociny(float x1, float y1)
{
		int i;
		float a,b,c,d;

		for(i=prvy_hrac; i<pocet_hracov; ++i)
		{
				if(pole_hracov[i].zivy)
				{
						a=pole_hracov[i].x-1;
						b=pole_hracov[i].x+1;
						c=pole_hracov[i].y-1;
						d=pole_hracov[i].y+1;

						if(x1>a && x1<b && y1>c && y1<d) return i;
				}
		}
		return -1;
}

int kokocina::over_prelinanie_kokociny()
{
		int pom=-1;

		pom=over_bod_kokociny(x-0.66,y-0.66);
		if(pom>=0) return pom;
		pom=over_bod_kokociny(x+0.66,y-0.66);
		if(pom>=0) return pom;
		pom=over_bod_kokociny(x-0.66,y+0.66);
		if(pom>=0) return pom;
		pom=over_bod_kokociny(x+0.66,y+0.66);
		if(pom>=0) return pom;

		return -1;
}

kokocina *p_k[5];

void initgl()
{
		glShadeModel(GL_SMOOTH);
		glDisable(GL_DEPTH_TEST);
		glFrontFace(GL_CCW);
		glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		gluPerspective(75,4.0/3,0.1,100);
		glMatrixMode(GL_MODELVIEW);
		glClearColor(0,0,0,0);
}

bool over_bod(int kto, float x1, float y1)
{
		float a,b,c,d;
		int i;

		for(i=prvy_hrac; i<pocet_hracov; ++i)
		{
				if(i==kto) continue;
				a=pole_hracov[i].x-1;
				b=pole_hracov[i].x+1;
				c=pole_hracov[i].y-1;
				d=pole_hracov[i].y+1;
				if(pole_hracov[i].zivy && x1>=a && x1<=b && y1>=c && y1<=d)return false;
		}
		return true;
}

bool over_strely(int kto)
{
		std::list<strela>::iterator i;

		for(i=v.begin(); i!=v.end(); ++i)
		{
				if(!i->smer) continue;
				if(i->povodca==kto) continue;

				if(i->x>=pole_hracov[kto].x-1 && i->x<=pole_hracov[kto].x+1 && 
								i->y>=pole_hracov[kto].y-1 && i->y<=pole_hracov[kto].y+1)
				{
						i->smer=0;
						if(!pole_hracov[kto].nesmrtelny) 
						{
								++pole_hracov[i->povodca].zabil;
								++pole_hracov[kto].mrtvy;
						}
						return false;
				}
		}
		return true;
}

void zmen_strelu(strela &ob)
{
		float pom1=timex*rychlost_strely,pom2=timex*rychlost_strely*0.9,pom3=timex*rychlost_strely*0.1;
		float pom4=timex*rychlost_strely*0.95,pom5=timex*rychlost_strely*0.05;

		if(!(ob.x>-18 && ob.x<18 && ob.y>-14 && ob.y<14))
				ob.smer=0;
		if(!over_prelinanie_prekazok(ob.x,ob.y))
				ob.smer=0;

		if(ob.smer==0) for(int it=0;it<10;++it)
			ps.createparticle(vector(ob.x,ob.y,0),vector(DFRAND,DFRAND,0)|(2*FRAND),vector(0,0,0),0.3,1,0,0,0,1,0.9,0.3);

		if(ob.smer==2)
		{
				if(ob.trojita==0) ob.x=ob.x+pom1;
				if(ob.trojita==1) 
				{
						ob.x=ob.x+pom2;
						ob.y=ob.y+pom3;
				}
				if(ob.trojita==2) 
				{
						ob.x=ob.x+pom2;
						ob.y=ob.y-pom3;
				}
				if(ob.trojita==3) 
				{
						ob.x=ob.x+pom4;
						ob.y=ob.y+pom5;
				}
				if(ob.trojita==4) 
				{
						ob.x=ob.x+pom4;
						ob.y=ob.y-pom5;
				}
		}
		if(ob.smer==4)
		{
				if(ob.trojita==0) ob.x=ob.x-pom1;
				if(ob.trojita==1) 
				{
						ob.x=ob.x-pom2;
						ob.y=ob.y+pom3;
				}
				if(ob.trojita==2) 
				{
						ob.x=ob.x-pom2;
						ob.y=ob.y-pom3;
				}
				if(ob.trojita==3) 
				{
						ob.x=ob.x-pom4;
						ob.y=ob.y+pom5;
				}
				if(ob.trojita==4) 
				{
						ob.x=ob.x-pom4;
						ob.y=ob.y-pom5;
				}
		}
		if(ob.smer==1)
		{
				if(ob.trojita==0) ob.y=ob.y+pom1;
				if(ob.trojita==1) 
				{
						ob.x=ob.x+pom3;
						ob.y=ob.y+pom2;
				}
				if(ob.trojita==2) 
				{
						ob.x=ob.x-pom3;
						ob.y=ob.y+pom2;
				}
				if(ob.trojita==3) 
				{
						ob.x=ob.x+pom5;
						ob.y=ob.y+pom4;
				}
				if(ob.trojita==4) 
				{
						ob.x=ob.x-pom5;
						ob.y=ob.y+pom4;
				}
		}
		if(ob.smer==3)
		{
				if(ob.trojita==0) ob.y=ob.y-pom1;
				if(ob.trojita==1) 
				{
						ob.x=ob.x+pom3;
						ob.y=ob.y-pom2;
				}
				if(ob.trojita==2) 
				{
						ob.x=ob.x-pom3;
						ob.y=ob.y-pom2;
				}
				if(ob.trojita==3) 
				{
						ob.x=ob.x+pom5;
						ob.y=ob.y-pom4;
				}
				if(ob.trojita==4) 
				{
						ob.x=ob.x-pom5;
						ob.y=ob.y-pom4;
				}
		}
}

void ci_sa_da_ist(int smer, int plejer)
{
		bool pokracovat;

		if(smer==1)
		{
				pokracovat=over_bod(plejer,pole_hracov[plejer].x-1.00,pole_hracov[plejer].y+1+posun*timex);
				if(pokracovat) 
						pokracovat=over_bod(plejer,pole_hracov[plejer].x+1.00,pole_hracov[plejer].y+1+posun*timex);
				if(pokracovat) 
						pokracovat=over_prelinanie_prekazok(pole_hracov[plejer].x-1.00,pole_hracov[plejer].y+1+posun*timex);
				if(pokracovat)
						pokracovat=over_prelinanie_prekazok(pole_hracov[plejer].x+1.00,pole_hracov[plejer].y+1+posun*timex);

				if(pokracovat && pole_hracov[plejer].y<13) pole_hracov[plejer].y+=posun*timex;
				pole_hracov[plejer].smer=1;
		}
		if(smer==2)
		{
				pokracovat=over_bod(plejer,pole_hracov[plejer].x+1+posun*timex,pole_hracov[plejer].y+1.00);
				if(pokracovat) 
						pokracovat=over_bod(plejer,pole_hracov[plejer].x+1+posun*timex,pole_hracov[plejer].y-1.00);
				if(pokracovat) 
						pokracovat=over_prelinanie_prekazok(pole_hracov[plejer].x+1+posun*timex,pole_hracov[plejer].y+1.00);
				if(pokracovat)
						pokracovat=over_prelinanie_prekazok(pole_hracov[plejer].x+1+posun*timex,pole_hracov[plejer].y-1.00);

				if(pokracovat && pole_hracov[plejer].x<17) pole_hracov[plejer].x+=posun*timex;
				pole_hracov[plejer].smer=2;
		}
		if(smer==3)
		{
				pokracovat=over_bod(plejer,pole_hracov[plejer].x-1.00,pole_hracov[plejer].y-1-posun*timex);
				if(pokracovat) 
						pokracovat=over_bod(plejer,pole_hracov[plejer].x+1.00,pole_hracov[plejer].y-1-posun*timex);
				if(pokracovat) 
						pokracovat=over_prelinanie_prekazok(pole_hracov[plejer].x-1.00,pole_hracov[plejer].y-1-posun*timex);
				if(pokracovat)
						pokracovat=over_prelinanie_prekazok(pole_hracov[plejer].x+1.00,pole_hracov[plejer].y-1-posun*timex);

				if(pokracovat && pole_hracov[plejer].y>-13) pole_hracov[plejer].y-=posun*timex;
				pole_hracov[plejer].smer=3;
		}
		if(smer==4)
		{
				pokracovat=over_bod(plejer,pole_hracov[plejer].x-1-posun*timex,pole_hracov[plejer].y+1.00);
				if(pokracovat) 
						pokracovat=over_bod(plejer,pole_hracov[plejer].x-1-posun*timex,pole_hracov[plejer].y-1.00);
				if(pokracovat) 
						pokracovat=over_prelinanie_prekazok(pole_hracov[plejer].x-1-posun*timex,pole_hracov[plejer].y+1.00);
				if(pokracovat)
						pokracovat=over_prelinanie_prekazok(pole_hracov[plejer].x-1-posun*timex,pole_hracov[plejer].y-1.00);

				if(pokracovat && pole_hracov[plejer].x>-17) pole_hracov[plejer].x-=posun*timex;
				pole_hracov[plejer].smer=4;
		}
}

void osetri_stisknute_klavesy()
{
		int i,pom;

		if(pole_hracov[1].zivy && exaIsKeyDown(EKEY_UP))
				ci_sa_da_ist(1,1);
		if(pole_hracov[1].zivy && exaIsKeyDown(EKEY_DOWN))
				ci_sa_da_ist(3,1);
		if(pole_hracov[1].zivy && exaIsKeyDown(EKEY_LEFT))
				ci_sa_da_ist(4,1);
		if(pole_hracov[1].zivy && exaIsKeyDown(EKEY_RIGHT))
				ci_sa_da_ist(2,1);

		if(pole_hracov[0].zivy && exaIsKeyDown('w'))
				ci_sa_da_ist(1,0);
		if(pole_hracov[0].zivy && exaIsKeyDown('s'))
				ci_sa_da_ist(3,0);
		if(pole_hracov[0].zivy && exaIsKeyDown('a'))
				ci_sa_da_ist(4,0);
		if(pole_hracov[0].zivy && exaIsKeyDown('d'))
				ci_sa_da_ist(2,0);

		for(i=2;i<pocet_hracov; ++i)
		{	
				if(!pole_hracov[i].zivy) continue;
				if(!pole_hracov[i].pom_cnp && pole_hracov[i].cas_nah_pohybu>0) 
				{
						pole_hracov[i].cas_nah_pohybu-=1;
						pom=0;
				}
				else
				{
						if(pole_hracov[i].cas_nah_pohybu>0)
						{
								pole_hracov[i].cas_nah_pohybu-=1;
								if(!pole_hracov[i].pom_cnp) pom=0;
								else pom=pole_hracov[i].smer;
						}
						else
						{
								pole_hracov[i].cas_nah_pohybu=(rand()%200)+100;
								pom=(rand()%10);	
								if(pom!=1 && pom!=2 && pom!=3 && pom!=4)
										pole_hracov[i].pom_cnp=0;
								else
										pole_hracov[i].pom_cnp=pom;
						}
				}

				if(pom==1)
						ci_sa_da_ist(1,i);
				if(pom==2)
						ci_sa_da_ist(2,i);
				if(pom==3)
						ci_sa_da_ist(3,i);
				if(pom==4)
						ci_sa_da_ist(4,i);
		}
}

int zmen_smer_blizko(int i,int pom2)
{
		if(pole_hracov[i].y>pole_hracov[pom2].y+4 ||
						pole_hracov[i].y<pole_hracov[pom2].y-4 ||
						pole_hracov[i].x>pole_hracov[pom2].x+4 ||
						pole_hracov[i].x<pole_hracov[pom2].x-4)
				return 1;

		if(pole_hracov[i].y<pole_hracov[pom2].y-2 &&
						pole_hracov[i].x<=pole_hracov[pom2].x+1 &&
						pole_hracov[i].x>=pole_hracov[pom2].x-1)	
				pole_hracov[i].smer=1;

		if(pole_hracov[i].y>pole_hracov[pom2].y+2 &&
						pole_hracov[i].x<=pole_hracov[pom2].x+1 &&
						pole_hracov[i].x>=pole_hracov[pom2].x-1)	
				pole_hracov[i].smer=3;

		if(pole_hracov[i].x>pole_hracov[pom2].x+2 &&
						pole_hracov[i].y<=pole_hracov[pom2].y+1 &&
						pole_hracov[i].y>=pole_hracov[pom2].y-1)	
				pole_hracov[i].smer=4;

		if(pole_hracov[i].x<pole_hracov[pom2].x-2 &&
						pole_hracov[i].y<=pole_hracov[pom2].y+1 &&
						pole_hracov[i].y>=pole_hracov[pom2].y-1)	
				pole_hracov[i].smer=2;

		return 0;
}

int zmen_smer_kokocina_blizko(int i, int j)
{
		if(pole_hracov[i].y>p_k[j]->y+4 ||
						pole_hracov[i].y<p_k[j]->y-4 ||
						pole_hracov[i].x>p_k[j]->x+4 ||
						pole_hracov[i].x<p_k[j]->x-4)
				return 1;

		if(pole_hracov[i].y<=p_k[j]->y &&
						pole_hracov[i].x<=p_k[j]->x+1.65 &&
						pole_hracov[i].x>=p_k[j]->x-1.65)	
		{
				pole_hracov[i].smer=1;
				if(pole_hracov[i].cas_nah_pohybu<1)
				{
						++pole_hracov[i].cas_nah_pohybu;
						pole_hracov[i].pom_cnp=5;
				}
		}

		if(pole_hracov[i].y>p_k[j]->y+1.65 &&
						pole_hracov[i].x<=p_k[j]->x+1.65 &&
						pole_hracov[i].x>=p_k[j]->x-1.65)	
		{
				pole_hracov[i].smer=3;
				if(pole_hracov[i].cas_nah_pohybu<1)
				{
						++pole_hracov[i].cas_nah_pohybu;
						pole_hracov[i].pom_cnp=5;
				}
		}

		if(pole_hracov[i].x>=p_k[j]->x+1.65 &&
						pole_hracov[i].y<=p_k[j]->y+1.65 &&
						pole_hracov[i].y>=p_k[j]->y-1.65)	
		{
				pole_hracov[i].smer=4;
				if(pole_hracov[i].cas_nah_pohybu<1)
				{
						++pole_hracov[i].cas_nah_pohybu;
						pole_hracov[i].pom_cnp=5;
				}
		}

		if(pole_hracov[i].x<p_k[j]->x-1.65 &&
						pole_hracov[i].y<=p_k[j]->y+1.65 &&
						pole_hracov[i].y>=p_k[j]->y-1.65)	
		{
				pole_hracov[i].smer=2;
				if(pole_hracov[i].cas_nah_pohybu<1)
				{
						++pole_hracov[i].cas_nah_pohybu;
						pole_hracov[i].pom_cnp=5;
				}
		}
		return 0;
}

int zmen_smer_kokocina_daleko(int i,int j)
{
		if(pole_hracov[i].y<p_k[j]->y+4 && 
						pole_hracov[i].y>p_k[j]->y-4) 
				if(pole_hracov[i].x>=p_k[j]->x)
				{
						pole_hracov[i].smer=4;
						return 0;
				}
				else
				{
						pole_hracov[i].smer=2;
						return 0;
				}

		if(pole_hracov[i].x<p_k[j]->x+4 && 
						pole_hracov[i].x>p_k[j]->x-4)
				if(pole_hracov[i].y<=p_k[j]->y)
				{
						pole_hracov[i].smer=1;
						return 0;
				}
				else
				{
						pole_hracov[i].smer=3;
						return 0;
				}
		return 1;
}

int zmen_smer_daleko(int i,int pom2)
{
		if(pole_hracov[i].y<pole_hracov[pom2].y+4 && 
						pole_hracov[i].y>pole_hracov[pom2].y-4) 
				if(pole_hracov[i].x>=pole_hracov[pom2].x)
				{
						pole_hracov[i].smer=4;
						return 0;
				}
				else
				{
						pole_hracov[i].smer=2;
						return 0;
				}

		if(pole_hracov[i].x<pole_hracov[pom2].x+4 && 
						pole_hracov[i].x>pole_hracov[pom2].x-4)
				if(pole_hracov[i].y<=pole_hracov[pom2].y)
				{
						pole_hracov[i].smer=1;
						return 0;
				}
				else
				{
						pole_hracov[i].smer=3;
						return 0;
				}
		return 1;
}

bool ignoruj(int i, float a, float b, bool kok)
{
		int j;

		if(pole_hracov[i].smer==1)
		{
				for(j=0;j<pocet_prekazok;++j)
				{
						if((prek[j]->y < pole_hracov[i].y) || 
										(prek[j]->y > b)) continue;
					if(kok)
					{
						if((prek[j]->x - prek[j]->polomer <= pole_hracov[i].x+1) 
										&& (prek[j]->x + prek[j]->polomer >= pole_hracov[i].x-1)) 
								return true;
					}
					else
						if((prek[j]->x + prek[j]->polomer > pole_hracov[i].x) &&
						(prek[j]->x - prek[j]->polomer < pole_hracov[i].x))
							return true;
				}
				return false;
		}

		if(pole_hracov[i].smer==2)
		{
				for(j=0;j<pocet_prekazok;++j)
				{
						if((prek[j]->x < pole_hracov[i].x) ||
										(prek[j]->x > a)) continue;
						if(kok)
						{
							if((prek[j]->y - prek[j]->polomer <= pole_hracov[i].y+1) 
										&& (prek[j]->y + prek[j]->polomer >= pole_hracov[i].y-1)) 
								return true;
						}
						else
						if((prek[j]->y + prek[j]->polomer > pole_hracov[i].y) &&
						(prek[j]->y - prek[j]->polomer < pole_hracov[i].y))
							return true;
				}
				return false;
		}
		if(pole_hracov[i].smer==3)
		{
				for(j=0;j<pocet_prekazok;++j)
				{
						if((prek[j]->y > pole_hracov[i].y) || 
										(prek[j]->y < b)) continue;
						if(kok)
						{
						if((prek[j]->x - prek[j]->polomer <= pole_hracov[i].x+1) 
										&& (prek[j]->x + prek[j]->polomer >= pole_hracov[i].x-1)) 
								return true;
						}
						else
						if((prek[j]->x + prek[j]->polomer > pole_hracov[i].x) &&
						(prek[j]->x - prek[j]->polomer < pole_hracov[i].x))
							return true;
				}
				return false;
		}
		if(pole_hracov[i].smer==4)
		{
				for(j=0;j<pocet_prekazok;++j)
				{
						if((prek[j]->x > pole_hracov[i].x) ||
										(prek[j]->x < a))  continue;
						if(kok)
						{
						if((prek[j]->y - prek[j]->polomer <= pole_hracov[i].y+1) 
										&& (prek[j]->y + prek[j]->polomer >= pole_hracov[i].y-1)) 
								return true;
						}
						else
						if((prek[j]->y + prek[j]->polomer > pole_hracov[i].y) &&
						(prek[j]->y - prek[j]->polomer < pole_hracov[i].y))
							return true;
				}
				return false;
		}
		return false;
}

bool over_vzdial_od_hracov(int kto, int pom, int pom2)
{
	int i;
	float vzdial,rozd_x,rozd_y;

	for(i=prvy_hrac; i<pocet_hracov; ++i)
	{
		if(i==kto) continue;
		rozd_x=pole_hracov[i].x-pom;
		rozd_y=pole_hracov[i].y-pom2;
		vzdial=sqrtf((rozd_x*rozd_x) + (rozd_y*rozd_y));
		if(vzdial<8) return false;
	}
	
	for(i=0;i<4;++i)
	{
		if(p_k[i]->zobrazit)
		{
			rozd_x=p_k[i]->x-pom;
			rozd_y=p_k[i]->y-pom2;
			vzdial=sqrtf((rozd_x*rozd_x) + (rozd_y*rozd_y));
			if(vzdial<6) return false;
		}
	}
	return true;
}

void generuj_nahodne_suradnice_hracov(int kto, int &pom, int &pom2)
{
		bool generuj=true;

		while(generuj)
		{
				pom=(rand()%(2*sirka_ploxy-1))-17;
				pom2=(rand()%(2*vyska_ploxy-1))-13;
				if(over_prelinanie_prekazok(pom-1,pom2-1) &&
								over_prelinanie_prekazok(pom+1,pom2-1) &&
								over_prelinanie_prekazok(pom+1,pom2+1) &&
								over_prelinanie_prekazok(pom-1,pom2+1) &&
								over_vzdial_od_hracov(kto,pom,pom2))
					generuj=false;
		}
}

ob_cas hodiny;

void vykresli_ficuru(GLuint obr, float a, float b, float c=0.5)
{
		glPushMatrix();
		glEnable(GL_TEXTURE_2D);
		glTranslatef(a,b,0);
		glColor3f(1,1,1);	
		glBindTexture(GL_TEXTURE_2D,obr);

		glBegin(GL_QUADS);
		glTexCoord2f(0,0);
		glVertex2f(-c,-c);
		glTexCoord2f(1,0);
		glVertex2f(c,-c);
		glTexCoord2f(1,1);
		glVertex2f(c,c);
		glTexCoord2f(0,1);
		glVertex2f(-c,c);
		glEnd();

		glColor3f(0,1,0);	
		glDisable(GL_TEXTURE_2D);
		glPopMatrix();
}

void skore()
{
		float rozdiel,pom=0;
		int i,hod;
		char buffer[256];

		glEnable(GL_BLEND); glBlendFunc(GL_ONE,GL_ONE); 
		glColor3f(0,1,0);

		rozdiel=30/(pocet_hracov-prvy_hrac);
		for(i=prvy_hrac;i<pocet_hracov;++i,pom+=rozdiel)
		{
				glPushMatrix();
				glTranslatef(-24.5,13.5-pom,0);
				if(i==1) napis.write("Hruscak");
				if(i==0) napis.write("Dvojka");
				if(i>1) napis.write("Hurnak");
				glPopMatrix();
				glPushMatrix();
				glTranslatef(-24.5,12-pom,0);
				sprintf(buffer,"%d",pole_hracov[i].zabil-pole_hracov[i].mrtvy);
				napis.write(buffer);
				glPopMatrix();
				if(pole_hracov[i].trojita_strela)
						vykresli_ficuru(obr_brokovka,-22,12.5-pom);
				if(pole_hracov[i].neviditelny)
						vykresli_ficuru(obr_neviditelnost,-20.5,12.5-pom);
				if(pole_hracov[i].nesmrtelny)
						vykresli_ficuru(obr_nesmrtelnost,-19,12.5-pom);
		}

		glPushMatrix();
		glTranslatef(-24,-15,0);
		hod=cas-hodiny.daj_cas();
		if(hod<=0) done=true;
		sprintf(buffer,"%d:%02d",hod/60,hod%60);
		glColor3f(1,0,0);
		napis.write(buffer);	
		glPopMatrix();
		glDisable(GL_BLEND);
}

int vyska=0;
int subvyska=0;

void kresli_pol(char *s, float a, float b, float c, int zviditelni)
{
		glPushMatrix();
		glColor3f(0,1,0);
		glTranslatef(a,b,c);
		if((a==-14 && b==vyska) || (a==6 && b==subvyska))
		{
				glTranslatef(0,-0.5,0);
				glScalef(1,2,1);
				glColor3f(0.9,0.5,0.1);
		}
		if(a==-6.5)
		{
			glScalef(1,2,1);
			glColor3f(0.5,0.5,1);
		}
		if(a==8.5)
		{
			glScalef(0.4,0.5,1);
			glColor3f(0.2,0.2,1);
		}
		napis.write(s);	
		glPopMatrix();
}

int submenu=0;

void menu_pocet_hr()
{
		if(exaIsKeyDown(EKEY_UP) && subvyska<6 && exaGetElapsedTime()>0.07) 
				subvyska+=2;
		if(exaIsKeyDown(EKEY_DOWN) && subvyska>-4 && exaGetElapsedTime()>0.07) 	
				subvyska-=2;
		kresli_pol("styria",6,0,-19,0);
		kresli_pol("traja",6,2,-19,0);
		kresli_pol("piati",6,-2,-19,0);
		kresli_pol("siesti",6,-4,-19,0);
		kresli_pol("dvaja",6,4,-19,0);
		kresli_pol("ziadni",6,6,-19,0);

		if(exaIsKeyDown(EKEY_RETURN) && exaGetElapsedTime()>0.07) 
		{
				switch(subvyska)
				{
						case 0: pocet_hracov=6;
								break;
						case 2: pocet_hracov=5;
								break;
						case 4: pocet_hracov=4;
								break;
						case 6: pocet_hracov=2;
								break;
						case -2: pocet_hracov=7;
								 break;
						case -4: pocet_hracov=8;
								 break;
				}
				submenu=0;
				subvyska=0;
		}
}

void menu_cas_hry()
{
		if(exaIsKeyDown(EKEY_UP) && subvyska<2 && exaGetElapsedTime()>0.07) 
				subvyska+=2;
		if(exaIsKeyDown(EKEY_DOWN) && subvyska>-2 && exaGetElapsedTime()>0.07) 	
				subvyska-=2;
		kresli_pol("90 sekund",6,0,-19,0);
		kresli_pol("60 sekund",6,2,-19,0);
		kresli_pol("200 sekund",6,-2,-19,0);
		if(exaIsKeyDown(EKEY_RETURN) && exaGetElapsedTime()>0.07) 
		{
				switch(subvyska)
				{
						case 0: cas=90;
								break;
						case 2: cas=60;
								break;
								break;
						case -2: cas=200;
								 break;
				}
				submenu=0;
				subvyska=0;
		}
}

void menu_prekazky()
{
		if(exaIsKeyDown(EKEY_UP) && subvyska<2 && exaGetElapsedTime()>0.07) 
				subvyska+=2;
		if(exaIsKeyDown(EKEY_DOWN) && subvyska>-4 && exaGetElapsedTime()>0.07) 	
				subvyska-=2;
		kresli_pol("bez prekazok",6,2,-19,0);
		kresli_pol("4 prekazky",6,0,-19,0);
		kresli_pol("6 prekazky",6,-2,-19,0);
		kresli_pol("8 prekazky",6,-4,-19,0);

		if(exaIsKeyDown(EKEY_RETURN) && exaGetElapsedTime()>0.07) 
		{
				switch(subvyska)
				{
						case 0: pocet_prekazok=4;
								break;
						case 2: pocet_prekazok=0;
								break;
						case -2: pocet_prekazok=6;
								 break;
						case -4: pocet_prekazok=8;
								 break;
				}
				submenu=0;
				subvyska=0;
		}
}

void menu_druhy_hrac()
{
		if(exaIsKeyDown(EKEY_UP) && subvyska<2 && exaGetElapsedTime()>0.07) 
				subvyska+=2;
		if(exaIsKeyDown(EKEY_DOWN) && subvyska>0 && exaGetElapsedTime()>0.07) 	
				subvyska-=2;
		kresli_pol("hra",6,0,-19,0);
		kresli_pol("nehra",6,2,-19,0);

		if(exaIsKeyDown(EKEY_RETURN) && exaGetElapsedTime()>0.07) 
		{
				switch(subvyska)
				{
						case 0: prvy_hrac=0;
								break;
						case 2: prvy_hrac=1;
								break;
				}
				submenu=0;
				subvyska=0;
		}
}

void menu_koniec_hry()
{
		if(exaIsKeyDown(EKEY_UP) && subvyska<2 && exaGetElapsedTime()>0.07) 
				subvyska+=2;
		if(exaIsKeyDown(EKEY_DOWN) && subvyska>0 && exaGetElapsedTime()>0.07) 	
				subvyska-=2;
		kresli_pol("ne, to bol zart!!",6,0,-19,0);
		kresli_pol("koniec, zdrham!",6,2,-19,0);

		if(exaIsKeyDown(EKEY_RETURN) && exaGetElapsedTime()>0.07) 
		{
				switch(subvyska)
				{
						case 0: break;
						case 2: done=true;
								total_end=true;
								break;
				}
				submenu=0;
				subvyska=0;
		}
}

void menu()
{
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity(); //reset modelview
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
		if(!(time(NULL)%2)) kresli_pol("HRUSCAK vs. HURNAK",-6.5,11,-19,0);
		kresli_pol("vydumal rg",8.5,-11,-19,0);
		kresli_pol("august 2007",8.5,-11.8,-19,0);
		if(exaIsKeyDown(EKEY_RETURN) && !submenu && vyska==0)
		{
				done=true;
				if(pocet_hracov==2) prvy_hrac=0;
		}
		glEnable(GL_BLEND); glBlendFunc(GL_ONE,GL_ONE); 
		glColor3f(0,1,0);

		if(!submenu && exaIsKeyDown(EKEY_UP) && vyska<4 && exaGetElapsedTime()>0.07) 
				vyska+=2;
		if(!submenu && exaIsKeyDown(EKEY_DOWN) && vyska>-6 && exaGetElapsedTime()>0.07) 	
				vyska-=2;
		glColor3f(1,0,0);
		glBegin(GL_TRIANGLES);
		glVertex3f(-16,1.5+vyska,-19);
		glVertex3f(-16,-0.5+vyska,-19);
		glVertex3f(-15,+0.5+vyska,-19);
		if(submenu)
		{
				glVertex3f(4,1.5+subvyska,-19);
				glVertex3f(4,-0.5+subvyska,-19);
				glVertex3f(5,+0.5+subvyska,-19);
		}
		glEnd();
		kresli_pol("Nova hra",-14,0,-19,0);
		kresli_pol("Pocet PC-hracov",-14,2,-19,0);
		kresli_pol("Cas hry",-14,-2,-19,0);
		kresli_pol("Prekazky",-14,-4,-19,0);
		kresli_pol("Druhy hrac",-14,4,-19,0);
		kresli_pol("Koniec srandy",-14,-6,-19,0);

		if(submenu==0)
		{
				if((exaIsKeyDown(EKEY_RIGHT) || exaIsKeyDown(EKEY_RETURN)) && vyska==-2 && exaGetElapsedTime()>0.07)
						submenu=2;
				if((exaIsKeyDown(EKEY_RIGHT) || exaIsKeyDown(EKEY_RETURN)) && vyska==2 && exaGetElapsedTime()>0.07) 
						submenu=1;
				if((exaIsKeyDown(EKEY_RIGHT) || exaIsKeyDown(EKEY_RETURN)) && vyska==4 && exaGetElapsedTime()>0.07)
						submenu=4;
				if((exaIsKeyDown(EKEY_RIGHT) || exaIsKeyDown(EKEY_RETURN)) && vyska==-4 && exaGetElapsedTime()>0.07)
						submenu=3;
				if((exaIsKeyDown(EKEY_RIGHT) || exaIsKeyDown(EKEY_RETURN)) && vyska==-6 && exaGetElapsedTime()>0.07)
						submenu=5;
		}
		if(submenu==1) menu_pocet_hr();
		if(submenu==2) menu_cas_hry();
		if(submenu==3) menu_prekazky();
		if(submenu==4) menu_druhy_hrac();
		if(submenu==5) menu_koniec_hry();
		if((exaIsKeyDown(EKEY_LEFT) || exaIsKeyDown(EKEY_RETURN)) && submenu>0 && exaGetElapsedTime()>0.07)
		{
				submenu=0;
				subvyska=0;
		}

		glDisable(GL_BLEND);
		glFinish(); //wait till drawing finishes
		exaglSwapBuffers(); //bring it to foreground
}

int kto_je_blizsie(int i)
{
	float vzdial1=0,vzdial2=0,rozd_x=0,rozd_y=0;

	if(prvy_hrac==1) return 1;
	if(!pole_hracov[0].zivy) return 1;
	if(!pole_hracov[1].zivy) return 0;

	rozd_x=pole_hracov[0].x-pole_hracov[i].x;
	rozd_y=pole_hracov[0].y-pole_hracov[i].y;
	vzdial1=sqrtf((rozd_x*rozd_x) + (rozd_y*rozd_y));
	rozd_x=pole_hracov[1].x-pole_hracov[i].x;
	rozd_y=pole_hracov[1].y-pole_hracov[i].y;
	vzdial2=sqrtf((rozd_x*rozd_x) + (rozd_y*rozd_y));
	if(vzdial1<vzdial2)
		return 0;
	else
		return 1;
}

void render()
{
		int i,j,pocet_zivyx,pom,pom2,strielaj_na;
		char farba;

		timex=exaGetElapsedTime();

		for(i=prvy_hrac; i<pocet_hracov; ++i)
		{
			if(pole_hracov[i].zivy)
			{
				pole_hracov[i].pauza+=timex;
				if(pole_hracov[i].pauza>100) pole_hracov[i].pauza=9;
			}
		}

		for(i=2; i<pocet_hracov; ++i)
		{
				j=pole_hracov[i].smer;
				strielaj_na=kto_je_blizsie(i);

				if(!pole_hracov[i].zivy) continue;
				if(pole_hracov[strielaj_na].zivy && !pole_hracov[strielaj_na].neviditelny)
				{
						pom=zmen_smer_blizko(i,strielaj_na);
						if(pom) pom=zmen_smer_daleko(i,strielaj_na);
				}
				else pom=1;

				if(!pom && ignoruj(i,pole_hracov[strielaj_na].x,pole_hracov[strielaj_na].y,false))	
				{
						pole_hracov[i].smer=j;//(rand()%4)+1;	
						pom=1;
				}

				if(p_k[2]->zobrazit)
				{
						if(pom) pom=zmen_smer_kokocina_blizko(i,2);
						if(pom) pom=zmen_smer_kokocina_daleko(i,2);
				}

				if(!pom && ignoruj(i,p_k[2]->x,p_k[2]->y,true))	
				{
						pole_hracov[i].smer=j;//(rand()%4)+1;	
						pom=1;
				}

				if(p_k[3]->zobrazit)
				{
						if(pom) pom=zmen_smer_kokocina_blizko(i,3);
						if(pom) pom=zmen_smer_kokocina_daleko(i,3);
				}

				if(!pom && ignoruj(i,p_k[3]->x,p_k[3]->y,true))	
				{
						pole_hracov[i].smer=j;//(rand()%4)+1;	
						pom=1;
				}

				if(p_k[0]->zobrazit)
				{
						if(pom) pom=zmen_smer_kokocina_blizko(i,0);
						if(pom) pom=zmen_smer_kokocina_daleko(i,0);
				}

				if(!pom && ignoruj(i,p_k[0]->x,p_k[0]->y,true))	
				{
						pole_hracov[i].smer=j;//(rand()%4)+1;	
						pom=1;
				}

				if(p_k[1]->zobrazit)
				{
						if(pom) pom=zmen_smer_kokocina_blizko(i,1);
						if(pom) pom=zmen_smer_kokocina_daleko(i,1);
				}

				if(!pom && ignoruj(i,p_k[1]->x,p_k[1]->y,true))	
				{
						pole_hracov[i].smer=j;//(rand()%4)+1;	
						pom=1;
				}
		}

		osetri_stisknute_klavesy();

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity(); //reset modelview
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
		glEnable(GL_TEXTURE_2D);
		glPointSize(6.0);
		glTranslatef(3.5,0,-22);

		if(pole_hracov[1].zivy && exaIsKeyDown(EKEY_SPACE))
		{
				if(pole_hracov[1].pauza>pauza_strely)
				{
						if(pole_hracov[1].trojita_strela)
								farba='c';
						else farba='z';

						v.push_back(strela(pole_hracov[1].x,pole_hracov[1].y,
												pole_hracov[1].z,pole_hracov[1].smer,1,0,farba));
						if(pole_hracov[1].trojita_strela)
						{
								v.push_back(strela(pole_hracov[1].x,pole_hracov[1].y,
														pole_hracov[1].z,pole_hracov[1].smer,1,1,farba));
								v.push_back(strela(pole_hracov[1].x,pole_hracov[1].y,
														pole_hracov[1].z,pole_hracov[1].smer,1,2,farba));
								v.push_back(strela(pole_hracov[1].x,pole_hracov[1].y,
														pole_hracov[1].z,pole_hracov[1].smer,1,3,farba));
								v.push_back(strela(pole_hracov[1].x,pole_hracov[1].y,
														pole_hracov[1].z,pole_hracov[1].smer,1,4,farba));
								--pole_hracov[1].trojita_strela;
						}
						pole_hracov[1].pauza=0;
				}
		}
		if(pole_hracov[0].zivy && exaIsKeyDown(EKEY_q))
		{
				if(pole_hracov[0].pauza>pauza_strely)
				{
						if(pole_hracov[0].trojita_strela)
								farba='c';
						else farba='z';

						v.push_back(strela(pole_hracov[0].x,pole_hracov[0].y,
												pole_hracov[0].z,pole_hracov[0].smer,0,0,farba));
						if(pole_hracov[0].trojita_strela)
						{
								v.push_back(strela(pole_hracov[0].x,pole_hracov[0].y,
														pole_hracov[0].z,pole_hracov[0].smer,0,1,farba));
								v.push_back(strela(pole_hracov[0].x,pole_hracov[0].y,
														pole_hracov[0].z,pole_hracov[0].smer,0,2,farba));
								v.push_back(strela(pole_hracov[0].x,pole_hracov[0].y,
														pole_hracov[0].z,pole_hracov[0].smer,0,3,farba));
								v.push_back(strela(pole_hracov[0].x,pole_hracov[0].y,
														pole_hracov[0].z,pole_hracov[0].smer,0,4,farba));
								--pole_hracov[0].trojita_strela;
						}
						pole_hracov[0].pauza=0;
				}
		}

		for(i=2; i<pocet_hracov; ++i)
		{
				if(!pole_hracov[i].zivy) continue;
				if(pole_hracov[i].pauza>pauza_strely*3)
				{
						pom=(rand()%4);
						if(pom==3)
						{
								if(pole_hracov[i].trojita_strela)
										farba='c';
								else farba='z';

								v.push_back(strela(pole_hracov[i].x,pole_hracov[i].y,
														pole_hracov[i].z,pole_hracov[i].smer,i,0,farba));
								if(pole_hracov[i].trojita_strela)
								{
										v.push_back(strela(pole_hracov[i].x,pole_hracov[i].y,
																pole_hracov[i].z,pole_hracov[i].smer,i,1,farba));
										v.push_back(strela(pole_hracov[i].x,pole_hracov[i].y,
																pole_hracov[i].z,pole_hracov[i].smer,i,2,farba));
										v.push_back(strela(pole_hracov[i].x,pole_hracov[i].y,
																pole_hracov[i].z,pole_hracov[i].smer,i,3,farba));
										v.push_back(strela(pole_hracov[i].x,pole_hracov[i].y,
																pole_hracov[i].z,pole_hracov[i].smer,i,4,farba));
										--pole_hracov[i].trojita_strela;
								}
								pole_hracov[i].pauza=0;
						}
				}
				if(pole_hracov[strielaj_na].zivy && !pole_hracov[strielaj_na].neviditelny && pole_hracov[i].pauza>pauza_strely && ((pole_hracov[i].x<pole_hracov[strielaj_na].x+2 && 
												pole_hracov[i].x>pole_hracov[strielaj_na].x-2) || 
										(pole_hracov[i].y<pole_hracov[strielaj_na].y+2 &&
										 pole_hracov[i].y>pole_hracov[strielaj_na].y-2)))
				{
						if(pole_hracov[i].trojita_strela)
								farba='c';
						else farba='z';

						v.push_back(strela(pole_hracov[i].x,pole_hracov[i].y,
												pole_hracov[i].z,pole_hracov[i].smer,i,0,farba));
						if(pole_hracov[i].trojita_strela)
						{
								v.push_back(strela(pole_hracov[i].x,pole_hracov[i].y,
														pole_hracov[i].z,pole_hracov[i].smer,i,1,farba));
								v.push_back(strela(pole_hracov[i].x,pole_hracov[i].y,
														pole_hracov[i].z,pole_hracov[i].smer,i,2,farba));
								v.push_back(strela(pole_hracov[i].x,pole_hracov[i].y,
														pole_hracov[i].z,pole_hracov[i].smer,i,3,farba));
								v.push_back(strela(pole_hracov[i].x,pole_hracov[i].y,
														pole_hracov[i].z,pole_hracov[i].smer,i,4,farba));
								--pole_hracov[i].trojita_strela;
						}
						pole_hracov[i].pauza=0;
				}
		}

		glBindTexture(GL_TEXTURE_2D,pozadie1);
		glColor3f(1,1,1);
		glBegin(GL_QUADS);//GL_LINE_LOOP);
		glTexCoord2f(0,0);
		glVertex2f(-18,-14);
		glTexCoord2f(1,0);
		glVertex2f(18,-14);
		glTexCoord2f(1,1);
		glVertex2f(18,14);
		glTexCoord2f(0,1);
		glVertex2f(-18,14);
		glEnd();

		for(i=0; i<pocet_prekazok; ++i)
				prek[i]->zobraz();

		for(i=prvy_hrac; i<pocet_hracov; ++i)
		{
				if(pole_hracov[i].neviditelny)
						--pole_hracov[i].neviditelny;
		}

		for(i=prvy_hrac; i<pocet_hracov; ++i)
		{
				if(pole_hracov[i].nesmrtelny)
						pole_hracov[i].nesmrtelny-=1;
				if(pole_hracov[i].zivy)
				{
						pole_hracov[i].zivy=over_strely(i);
						if(pole_hracov[i].nesmrtelny)
								pole_hracov[i].zivy=true;
						if(!pole_hracov[i].zivy) 
						{
							for(int it=0;it<500;++it)
								ps.createparticle(vector(pole_hracov[i].x,
								pole_hracov[i].y,0),
								vector(DFRAND,DFRAND,0)|(FRAND*3),vector(0,0,0),
								1,FRAND*4,0,0,0,1,FRAND,0.1);
							pole_hracov[i].cas_smrti=time(NULL);
						}
				}
				if(pole_hracov[i].zivy && !pole_hracov[i].neviditelny && 
								!(pole_hracov[i].nesmrtelny>500 && pole_hracov[i].nesmrtelny<530)&&
								!(pole_hracov[i].nesmrtelny>300 && pole_hracov[i].nesmrtelny<330)&&
								!(pole_hracov[i].nesmrtelny>100 && pole_hracov[i].nesmrtelny<130))
				{
						glPushMatrix();
						glTranslatef(pole_hracov[i].x,pole_hracov[i].y,0);
						glColor3f(1,1,1);
						if(pole_hracov[i].smer==1)
								glBindTexture(GL_TEXTURE_2D,textura);
						if(pole_hracov[i].smer==2)
								glBindTexture(GL_TEXTURE_2D,textura2);
						if(pole_hracov[i].smer==3)
								glBindTexture(GL_TEXTURE_2D,textura3);
						if(pole_hracov[i].smer==4)
								glBindTexture(GL_TEXTURE_2D,textura4);

						if(i==1)
						{
								if(pole_hracov[i].smer==1)
										glBindTexture(GL_TEXTURE_2D,hruscak1);
								if(pole_hracov[i].smer==2)
										glBindTexture(GL_TEXTURE_2D,hruscak2);
								if(pole_hracov[i].smer==3)
										glBindTexture(GL_TEXTURE_2D,hruscak3);
								if(pole_hracov[i].smer==4)
										glBindTexture(GL_TEXTURE_2D,hruscak4);
						}

						if(i==0)
						{
								if(pole_hracov[i].smer==1)
										glBindTexture(GL_TEXTURE_2D,druhy1);
								if(pole_hracov[i].smer==2)
										glBindTexture(GL_TEXTURE_2D,druhy2);
								if(pole_hracov[i].smer==3)
										glBindTexture(GL_TEXTURE_2D,druhy3);
								if(pole_hracov[i].smer==4)
										glBindTexture(GL_TEXTURE_2D,druhy4);
						}

						glBegin(GL_QUADS);
						glTexCoord2f(0,0);
						glVertex2f(-1,-1);
						glTexCoord2f(1,0);
						glVertex2f(1,-1);
						glTexCoord2f(1,1);
						glVertex2f(1,1);
						glTexCoord2f(0,1);
						glVertex2f(-1,1);
						glEnd();

						glPopMatrix();
				}
		}

		for(i=0;i<4;++i)
		{
				if(p_k[i]->zobrazit)
				{
						pom=p_k[i]->over_prelinanie_kokociny();
						if(pom==-1)
								p_k[i]->zobraz();
						else
						{
								if(i==0)pole_hracov[pom].trojita_strela=5;
								if(i==1)pole_hracov[pom].neviditelny=2000;
								if(i==2)
								{
									for(j=prvy_hrac;j<pocet_hracov;++j)	
										if(j!=pom) 
										{								
											if(pole_hracov[j].zivy) 
											{
												++pole_hracov[pom].zabil;
												++pole_hracov[j].mrtvy;
												pole_hracov[j].zivy=false;
												pole_hracov[j].cas_smrti=time(NULL);
												for(int it=0;it<500;++it)
													ps.createparticle(vector(pole_hracov[j].x,pole_hracov[j].y,0),
													vector(DFRAND,DFRAND,0)|(FRAND*3),vector(0,0,0),
													1,FRAND*4,0,0,0,1,FRAND,0.1);
											}
										}
								}
								if(i==3)
										pole_hracov[pom].nesmrtelny=3000;
								p_k[i]->zobrazit=false;
						}
				}
				else
				{
						if(i==0)
								pom=rand()%4000;
						if(i==1)
								pom=rand()%12000;
						if(i==2)
								pom=rand()%20000;
						if(i==3)
								pom=rand()%15000;
						if(pom==0)
						{
								generuj_nahodne_suradnice_hracov(-1,pom,pom2);
								p_k[i]->zobrazit=true;
								p_k[i]->zmen_polohu(pom,pom2,0);		
						}
				}
		}

		glDisable(GL_TEXTURE_2D);
		pocet_zivyx=0;
		for(i=prvy_hrac; i<pocet_hracov;++i)
				if(pole_hracov[i].zivy) ++pocet_zivyx;

		std::list<strela>::iterator li,lit;
		for(li=v.begin();li!=v.end();++li)
		{
				if(li->farba=='c')
						glColor3f(1,0,0);
				else glColor3f(0,1,0);
				if(li->smer)
				{
						zmen_strelu(*li);
						glBegin(GL_POINTS);
						glVertex3f(li->x,li->y,0);
						glEnd();
				}	
		}
		for(li=v.begin();li!=v.end();++li)
			if(!li->smer){lit=li--;v.erase(lit);}

		if(pocet_zivyx<pocet_hracov-prvy_hrac)
		{
			for(i=prvy_hrac;i<pocet_hracov;++i)	
				if(!pole_hracov[i].zivy && 
				((time(NULL)-pole_hracov[i].cas_smrti)>=3))
				{
						generuj_nahodne_suradnice_hracov(i,pom,pom2);
						pole_hracov[i].vynuluj_sa(pom,pom2,0,(rand()%4)+1);		
				}
		}

		skore();

		//ps.createparticle(vector(0,0,0),vector(DFRAND,DFRAND,DFRAND)|20,vector(0,-100,0),1,5.5,0,0,0,FRAND,FRAND,FRAND);
		ps.update(timex);
		glBindTexture(GL_TEXTURE_2D,obr_vybux);
		glEnable(GL_TEXTURE_2D);
		glEnable(GL_BLEND);
		glBlendFunc(GL_ONE,GL_ONE);
		ps.draw(orientation(0,0,-1,0,1,0));
		glDisable(GL_TEXTURE_2D);
		glDisable(GL_BLEND);

		glFinish(); //wait till drawing finishes
		exaglSwapBuffers(); //bring it to foreground
}

void vysledok()
{
		float pom=0,rozdiel=0;
		char buffer[256];
		int i=0;

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity(); //reset modelview
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
		glEnable(GL_BLEND); glBlendFunc(GL_ONE,GL_ONE); 

		rozdiel=45/(pocet_hracov-prvy_hrac);
		for(i=prvy_hrac;i<pocet_hracov;++i,pom+=rozdiel)
		{
				glColor3f(0,1,0);
				glPushMatrix();
				glTranslatef(-20+pom,10,-22);
				if(i==1)
						napis.write("Hruscak");
				if(i==0) napis.write("Dvojka");
				if(i>1) napis.write("Hurnak");
				glPopMatrix();
				glPushMatrix();
				glTranslatef(-18+pom,13,-22);
				if(i==1)
						vykresli_ficuru(hruscak1,0,0,1);
				if(i!=1)
						vykresli_ficuru(textura,0,0,1);
				glPopMatrix();
				glPushMatrix();
				glTranslatef(-18+pom,8,-22);
				glColor3f(1,0,0);
				sprintf(buffer,"%d",pole_hracov[i].zabil-pole_hracov[i].mrtvy);
				napis.write(buffer);
				glPopMatrix();

				glPushMatrix();
				glTranslatef(-20+pom,3,-22);
				glColor3f(0.5,0.5,1);
				sprintf(buffer,"zabil: %d",pole_hracov[i].zabil);
				glScalef(0.7,0.7,0.7);
				napis.write(buffer);
				glPopMatrix();

				glPushMatrix();
				glTranslatef(-20+pom,1,-22);
				glColor3f(0.5,0.5,1);
				sprintf(buffer,"mrtvy: %d",pole_hracov[i].mrtvy);
				glScalef(0.7,0.7,0.7);
				napis.write(buffer);
				glPopMatrix();
		}

		glDisable(GL_BLEND);
		glFinish(); //wait till drawing finishes
		exaglSwapBuffers(); //bring it to foreground
}

void zobraz_vysl()
{
		bool done=false;

		while(!done)
		{
				exaUSleep(2);
				exaUpdate();
				//update cycle - wm and KB stuff
				if(exaIsKeyDown(EKEY_ESCAPE) || exaIsKeyDown(EKEY_RETURN))
				{
						done=true;
				}
				if(exaIsKeyDown(EKEY_TAB))exaIconifyWindow();
				//iconify=minimize
				if(!exaIsIconified()) vysledok();
				//render only if it will be seen
		}
}

int main()
{
		int i,pom,pom2;
		bool zobraz_vysledok=true;

		srand(time(NULL));
		exaSetParams(1024,768,32); //set your own
		if(!exaInit())return -1;
		load_texture();
		initgl();
		ps.init(4096);

		for(i=0;i<10;++i)
			prek[i]=0;
		napis.loadfromfreetype("verdana.ttf");

		p_k[0]=new brokovka(-4,5,0);
		p_k[1]=new neviditelnost(-4,5,0);
		p_k[2]=new bomba(-4,5,0);
		p_k[3]=new nesmrtelnost(-4,5,0);

		while(!total_end)
		{
				vyska=0;
				hodiny.vynuluj();
				while(!done)
				{
						exaUSleep(2);
						exaUpdate();
						//update cycle - wm and KB stuff
						if(exaIsKeyDown(EKEY_ESCAPE))
						{
								done=true;
								total_end=1;
								//exit on escape
						}
						if(exaIsKeyDown(EKEY_TAB))exaIconifyWindow();
						//iconify=minimize
						if(!exaIsIconified()) menu();
						//render only if it will be seen
				}
				done=false;
				if(total_end) break;

				for(i=0;i<pocet_prekazok;++i)
				{
						if(prek[i]) delete(prek[i]);
						pom=(rand()%3)+3;
						prek[i]=new prekazky((rand()%(2*sirka_ploxy-2*pom+1))-sirka_ploxy+pom,(rand()%(2*vyska_ploxy-2*pom+1))-vyska_ploxy+pom,pom-2);		
				}

				for(i=prvy_hrac;i<pocet_hracov;++i)
				{
						generuj_nahodne_suradnice_hracov(i,pom,pom2);
						pole_hracov[i].vynuluj_sa(pom,pom2,0,(rand()%4)+1);		
						pole_hracov[i].zabil=0;
						pole_hracov[i].mrtvy=0;
				}

				for(i=0;i<4;++i)
					p_k[i]->zobrazit=false;

				hodiny.vynuluj();
				zobraz_vysledok=true;
				while(!done)
				{
						exaUSleep(2);
						exaUpdate();
						//update cycle - wm and KB stuff
						if(exaIsKeyDown(EKEY_ESCAPE))
						{
								done=true;
								zobraz_vysledok=false;
								//total_end=1;
								//exit on escape
						}
						if(exaIsKeyDown(EKEY_TAB))exaIconifyWindow();
						//iconify=minimize
						if(!exaIsIconified()) render();
						//render only if it will be seen
				}
				if(zobraz_vysledok)
						zobraz_vysl();
				if(!total_end) exaUSleep(300000);

				v.clear();
				done=false;
		}
		ps.release();
		release_texture();
		exaShutdown();
		return 0;
}
